"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var marked_1 = require("@connectv/marked");
function plug(config, plugin) {
    var _a;
    var override = plugin(config);
    if (override.src)
        config.src = Object.assign({}, override.src, config.src);
    if (override.dest)
        config.dest = Object.assign({}, override.dest, config.dest);
    if (override.bundle)
        config.bundle.init = config.bundle.init.concat(override.bundle.init || []);
    if (override.page) {
        if (override.page.title)
            config.page.title = Object.assign({}, override.page.title, config.page.title);
        if (override.page.favicon)
            config.page.favicon = config.page.favicon || override.page.favicon;
        if (override.page.meta)
            config.page.meta = Object.assign({}, override.page.meta, config.page.meta, {
                keywords: __spreadArrays(((_a = config.page.meta) === null || _a === void 0 ? void 0 : _a.keywords) || [], override.page.meta.keywords || [])
            });
        if (override.page.fonts)
            config.page.fonts = Object.assign({}, override.page.fonts, config.page.fonts);
        if (override.page.scripts)
            config.page.scripts = (config.page.scripts || []).concat(override.page.scripts);
        if (override.page.stylesheets)
            config.page.stylesheets = (config.page.stylesheets || []).concat(override.page.stylesheets);
        if (override.page.post)
            config.page.post = (config.page.post || []).concat(override.page.post);
    }
    if (override.dev)
        config.dev = Object.assign({}, override.dev, config.dev);
    if (override.markdown) {
        config.markdown = Object.assign({}, override.markdown, config.markdown, {
            customComponents: __assign(__assign({}, override.markdown.customComponents), config.markdown.customComponents),
            customInlineComponents: __assign(__assign({}, override.markdown.customInlineComponents), config.markdown.customInlineComponents),
        });
        if (override.markdown.customComponents)
            config.markdown.BlockQuote = marked_1.quotedComponents(config.markdown.customComponents);
        if (override.markdown.customInlineComponents)
            config.markdown.Link = marked_1.linkedComponents(config.markdown.customInlineComponents);
    }
    if (override.tocMarkdown) {
        config.tocMarkdown = Object.assign({}, override.tocMarkdown, config.tocMarkdown, {
            customComponents: __assign(__assign({}, override.tocMarkdown.customComponents), config.tocMarkdown.customComponents),
            customInlineComponents: __assign(__assign({}, override.tocMarkdown.customInlineComponents), config.tocMarkdown.customInlineComponents),
        });
        if (override.tocMarkdown.customComponents)
            config.tocMarkdown.BlockQuote = marked_1.quotedComponents(config.tocMarkdown.customComponents);
        if (override.tocMarkdown.customInlineComponents)
            config.tocMarkdown.Link = marked_1.linkedComponents(config.tocMarkdown.customInlineComponents);
    }
    if (override.misc)
        config.misc = Object.assign({}, override.misc, config.misc);
    return config;
}
exports.plug = plug;
//# sourceMappingURL=plugin.js.map